#!/usr/bin/eperl -w
###
#
# Copyright (c) Ensim Corporation 2000, 2001   All Rights Reserved.
#
# This software is furnished under a license and may be used and copied
# only  in  accordance  with  the  terms  of such  license and with the
# inclusion of the above copyright notice. This software or any other
# copies thereof may not be provided or otherwise made available to any
# other person. No title to and ownership of the software is hereby
# transferred.
#
# The information in this software is subject to change without notice
# and  should  not be  construed  as  a commitment by Ensim Corporation.
# Ensim assumes no responsibility for the use or  reliability  of its
# software on equipment which is not supplied by Ensim.
#
#
###
# --------------------------------------------------------------------------
# $Id: 
# $Name:  $
# --------------------------------------------------------------------------

use strict;
my $emailfile = "/etc/opcenter/webhost/alert_addr";
my $mb_threshold = 20;
my ($content, $hostname)= ("", "");
my $webserver; 
my $dfproblem;
my @lines;
my $line;


unless ( -e $emailfile ) { die "Cannot retrieve the email file. Alarm is not activated. \n"} 

#(I dont care and wont fail if failed to get hostname)
$hostname = "the machine running WEBppliance";
$webserver = "<Web server name could not be retrieved>";
if ( open(HOST, "hostname |") ) {
    my @buf = <HOST>;
    close HOST;    
    $hostname = $buf[0];
    chop $hostname;
    $webserver = $hostname;
}

my $subject = "WEBppliance Alert" ;
my $header = $subject . "\n" ; 
my $footer = "An email will be sent to you every hour until you disable the alarm by setting the email alert field to empty through the following url:\n" . "http://$webserver/admin \n\n" .
    "This is a generated message. \n\n";

if (open (DF, "/bin/df -m |")) { 
    @lines =<DF>;
    close DF;
    $dfproblem = 0;
} else {
    #woops, df failed. Let's send panic alarm
    $content = "The \"/bin/df -m\" command failed on $hostname.\n" .
	"Please try to fix your system.\n".
	"The Alert feature of your WEBppliance server will not work until this problem is addressed.\n";
    $dfproblem = 1;
}

my $danger = 0;

unless ($dfproblem) {
    my $flag;

    foreach $line (@lines) {
	next if ( $line =~ /^Filesystem*/ );
	chop ($line);

	my (@fields) = split(/\s+/, $line);
	$flag = "";
	if ($fields[3] < $mb_threshold) {
	    $flag = "*";
	    $danger = 1;
	    #the ouput of df: partition, used, available, mount point
	}
	$content = $content . "$flag\t$fields[0]\t\t$fields[2]\t\t$fields[3]\t\t$fields[5]\n";
    }
    #if some partition is tight, add a header, else flush content
    if ($danger) {
	$content = "Disk space on one or more partitions on $hostname is low, below $mb_threshold MB.\n" .
	    "WEBppliance might not function properly if you do not address this problem.\n" .
	    "Please find the summary of disk usage/available (in MB) below.\n" .
	    "An asterisk signifies that the disk space of a particular partition is below the suggested safe threshold. \n\n" .
	    "\tFilesystem\t\tUsed\t\tFree\t\tMounted on\n" . 
	    $content . "\n\n"; 
    } else {
	$content = "";
    }
}

#if nothing is populated, no problemo...
unless ($danger) {exit 0}
#otherwise, I have to send alert email
$content = $header . $content . $footer ;

my $address;
unless (open (ADDR, $emailfile)) {die "Can not retrieve the email address to send alert to"} 
$address = <ADDR>;
close ADDR;
chomp $address;

system("echo \'$content\' | mail $address -s \'$subject\'");
exit 0;








