#!/usr/bin/env perl -w

package Carper;
use IO::Handle;

require Exporter;
our @ISA = ("Exporter");

our @EXPORT = qw($cerr);

my @errmsgs = () ;

use overload '+' => \&contextdict, 'bool' => sub { return @_ } ;

sub ctor {
    my $ERRPIPEHANDLE;
    my $fdesc = $ENV{ERRFD} || 2 ;
    my ($this) = {} ;
    bless $this, "Carper" ;
    # mansoor (Fall back to STDERR if things go wrong)
    open ($ERRPIPEHANDLE, ">&=$fdesc" ) or 
        open ($ERRPIPEHANDLE, ">&=2") or
        die "can't open error pipe <$fdesc>";
    $this->{fd} = $ERRPIPEHANDLE ;
    return $this ;
}

sub is_hash { ref $_[0] eq 'HASH' ? 1: 0 }

sub contextdict {
    my($this) = shift ;
    my($arg) = shift;

    # now the argument is a reference. we need to check if the referent is
    # a scalar or a hash. If it is a scalar,then we treat it as an error code
    # if not, then we treat it as a context dict

    #if (%{$_[0]}) {
    if (is_hash($arg)) {
        # argument is a hash
        my %cdict = %{$arg};
        my $key ;
        for $key (keys %cdict) {
            $this->{fd}->print("$key=$cdict{$key}\n");
        }
    }
    else {
        # argument is a single value, interpret as error code
        $this->{fd}->print("ERROR:$arg\n");
    }

    return $this ;
}

sub DESTROY {
    # XXX free up instance-specific resources
}

BEGIN {
    $cerr = ctor () if not $cerr;
}

END {
}

1;

