##############################################################################
# 
# Zope Public License (ZPL) Version 1.0
# -------------------------------------
# 
# Copyright (c) Digital Creations.  All rights reserved.
# 
# This license has been certified as Open Source(tm).
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
# 
# 1. Redistributions in source code must retain the above copyright
#    notice, this list of conditions, and the following disclaimer.
# 
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions, and the following disclaimer in
#    the documentation and/or other materials provided with the
#    distribution.
# 
# 3. Digital Creations requests that attribution be given to Zope
#    in any manner possible. Zope includes a "Powered by Zope"
#    button that is installed by default. While it is not a license
#    violation to remove this button, it is requested that the
#    attribution remain. A significant investment has been put
#    into Zope, and this effort will continue if the Zope community
#    continues to grow. This is one way to assure that growth.
# 
# 4. All advertising materials and documentation mentioning
#    features derived from or use of this software must display
#    the following acknowledgement:
# 
#      "This product includes software developed by Digital Creations
#      for use in the Z Object Publishing Environment
#      (http://www.zope.org/)."
# 
#    In the event that the product being advertised includes an
#    intact Zope distribution (with copyright and license included)
#    then this clause is waived.
# 
# 5. Names associated with Zope or Digital Creations must not be used to
#    endorse or promote products derived from this software without
#    prior written permission from Digital Creations.
# 
# 6. Modified redistributions of any form whatsoever must retain
#    the following acknowledgment:
# 
#      "This product includes software developed by Digital Creations
#      for use in the Z Object Publishing Environment
#      (http://www.zope.org/)."
# 
#    Intact (re-)distributions of any official Zope release do not
#    require an external acknowledgement.
# 
# 7. Modifications are encouraged but must be packaged separately as
#    patches to official Zope releases.  Distributions that do not
#    clearly separate the patches from the original work must be clearly
#    labeled as unofficial distributions.  Modifications which do not
#    carry the name Zope may be packaged in any form, as long as they
#    conform to all of the clauses above.
# 
# 
# Disclaimer
# 
#   THIS SOFTWARE IS PROVIDED BY DIGITAL CREATIONS ``AS IS'' AND ANY
#   EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
#   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
#   PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL DIGITAL CREATIONS OR ITS
#   CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
#   USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
#   ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
#   OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
#   OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
#   SUCH DAMAGE.
# 
# 
# This software consists of contributions made by Digital Creations and
# many individuals on behalf of Digital Creations.  Specific
# attributions are listed in the accompanying credits file.
# 
##############################################################################

# functionalized zope's z2.py

def startzope(in_args,gns, daemonize_func):
    import os, sys, getopt, string

    #import ocwstart
    #ocwstart.register()

    program=sys.argv[0]
    here=os.path.join(os.getcwd(), os.path.split(program)[0])
    Zpid=''

    ########################################################################
    # Configuration section

    if sys.platform=='win32': Zpid=''
    else: Zpid='var/zProcessManager.pid'

    IP_ADDRESS=''
    DNS_IP=''
    UID='nobody'
    LOG_FILE='Z2.log'
    HTTP_PORT=8080
    HTTP_ENV={}
    FTP_PORT=8021
    PCGI_FILE='Zope.cgi'
    MONITOR_PORT=8099
    MODULE='Zope'
    NUMBER_OF_THREADS=4
    FCGI_PORT = None

    if string.split(sys.version)[0] < '1.5.2':
        raise 'Invalid python version', string.split(sys.version)[0]

    # changed by Naris #####
    opts, args = getopt.getopt(in_args, 'hz:M:Z:t:a:d:u:w:f:p:m:Sl:2DP:rF:')
    ########################

    DEBUG=0
    READ_ONLY=0

    # Get environment variables
    for a in args:
        if string.find(a,'='):
            a=string.split(a,'=')
            o=a[0]
            v=string.join(a[1:],'=')
            if o: 
              os.environ[o]=v
              HTTP_ENV[o]=v
        else:
            raise 'Invalid argument', a

    for o, v in opts:
        if o=='-z': here=v

        # changed by Naris ######
        elif o=='-M': MODULE=v
        #########################

        elif o=='-Z': Zpid=v
        elif o=='-r': READ_ONLY=1
        elif o=='-t':
            try: v=string.atoi(v)
            except: raise 'Invalid number of threads', v
            NUMBER_OF_THREADS=v
        elif o=='-a': IP_ADDRESS=v
        elif o=='-d': DNS_IP=v
        elif o=='-u': UID=v
        elif o=='-D':
            os.environ['Z_DEBUG_MODE']='1'
            DEBUG=1
        elif o=='-S': sys.ZMANAGED=1
        elif o=='-m':
            if v:
                try: 
                    v=string.atoi(v)
                    if v < 1: raise 'Invalid port', v
                except: raise 'Invalid port', v
            MONITOR_PORT=v
        elif o=='-w':
            if v:
                try: 
                    v=string.atoi(v)
                    if v < 1: raise 'Invalid port', v
                except: raise 'Invalid port', v
            HTTP_PORT=v
        elif o=='-f':
            if v:
                try:
                    v=string.atoi(v)
                    if v < 1: raise 'Invalid port', v
                except: raise 'Invalid port', v
            FTP_PORT=v
        elif o=='-P':
            if v:
                try: v=string.atoi(v)
                except: raise 'Invalid port', v
            FTP_PORT=v+21
            HTTP_PORT=v+80
            MONITOR_PORT=v+99
        elif o=='-p': PCGI_FILE=v
        elif o=='-h':
            print __doc__ % vars()
            sys.exit(0)
        elif o=='-2': MODULE='Main'
        elif o=='-l': LOG_FILE=v
        elif o=='-F': FCGI_PORT=v

    gns.__debug__ = DEBUG

    if sys.platform=='win32': Zpid=''

    #
    ########################################################################

    ########################################################################
    # OK, let's get going!

    # Jigger path:
    #sys.path=[os.path.join(here,'lib','python'),
    #          here
    #          ]+filter(None, sys.path)


    # from this point forward we can use the zope logger

    # Import ZServer before we open the database or get at interesting
    # application code so that ZServer's asyncore gets to be the
    # official one.
    import ZServer

    if Zpid and not READ_ONLY:
        import zdaemon, App.FindHomes, posix
        sys.ZMANAGED=1

        zdaemon.run(sys.argv, os.path.join(INSTANCE_HOME, Zpid))

    # Import Zope (or Main), and thus get SOFTWARE_HOME and INSTANCE_HOME
    exec "import "+MODULE in {}

    import zLOG

    # Changed by Naris...skipped
    # loading of zope server
    # since zope requires an access file, which
    # we don't need.

    #from Zope import ZLogger

    # Can't easily use 
    #if READ_ONLY:
    INSTANCE_HOME=os.environ['INSTANCE_HOME']
    #zLOG._stupid_dest=sys.stderr
    #zLOG._stupid_dest=None
    #else:
    #    zLOG.log_write = ZLogger.ZLogger.log_write


    # Location of the ZServer log file. This file logs all ZServer activity.
    # You may wish to create different logs for different servers. See
    # medusa/logger.py for more information.
    if not os.path.isabs(LOG_FILE):
        LOG_PATH=os.path.join(INSTANCE_HOME, 'var', LOG_FILE)
    else:
        LOG_PATH=LOG_FILE

    # Location of the ZServer pid file. When ZServer starts up it will write
    # its PID to this file.

    PID_FILE=os.path.join(INSTANCE_HOME, 'var', 'Z2.pid')

    # import ZServer stuff

    # First, we need to increase the number of threads
    # changed by naris...allow for threads
    #if MODULE=='Zope':
    from ZServer import setNumberOfThreads
    setNumberOfThreads(NUMBER_OF_THREADS)

    from ZServer import resolver, logger, asyncore
    from ZServer import zhttp_server, zhttp_handler, PCGIServer,FCGIServer,FTPServer
    from ZServer import secure_monitor_server

    ## ZServer startup
    ##

    # Resolver and Logger, used by other servers
    if DNS_IP:
        rs = resolver.caching_resolver(DNS_IP)
    else:
        rs=None

    lg = logger.file_logger('-') # log to stdout

    # HTTP Server
    if HTTP_PORT:
        hs = zhttp_server(
            ip=IP_ADDRESS,
            port=HTTP_PORT,
            resolver=rs,
            logger_object=lg)

        # Handler for a published module. zhttp_handler takes 3 arguments:
        # The name of the module to publish, and optionally the URI base
        # which is basically the SCIRPT_NAME, and optionally a dictionary
        # with CGI environment variables which override default
        # settings. The URI base setting is useful when you want to
        # publish more than one module with the same HTTP server. The CGI
        # environment setting is useful when you want to proxy requests
        # from another web server to ZServer, and would like the CGI
        # environment to reflect the CGI environment of the other web
        # server.    

        # Enism Fix:
        #   Zope handles streaming in a very silly way. To fix that we
        #   need to introduce our own Response object. That object is
        #   created by the zhttp_handler.
        from my_zhttp_handler import my_zhttp_handler

        zh = my_zhttp_handler(MODULE, '', HTTP_ENV)
        hs.install_handler(zh)


    # FTP Server
    if FTP_PORT:
        zftp = FTPServer(
            module=MODULE,
            port=FTP_PORT,
            resolver=rs,
            logger_object=lg)

    # PCGI Server
    if PCGI_FILE and not READ_ONLY:
        PCGI_FILE=os.path.join(here, PCGI_FILE)
        if os.path.exists(PCGI_FILE):
            zpcgi = PCGIServer(
                module=MODULE,
                ip=IP_ADDRESS,
                pcgi_file=PCGI_FILE,
                resolver=rs,
                logger_object=lg)

    if FCGI_PORT and not READ_ONLY:
        fcgiPort = None
        fcgiPath = None
        try:
            fcgiPort = string.atoi(FCGI_PORT)
        except ValueError:
            fcgiPath = FCGI_PORT
        from my_zhttp_handler import my_FCGIServer
        zfcgi = my_FCGIServer(module=MODULE,
                              ip=IP_ADDRESS,
                              port=fcgiPort,
                              socket_file=fcgiPath,
                              resolver=rs,
                              logger_object=lg)

    # Monitor Server
    if MONITOR_PORT:
        from AccessControl.User import super
        monitor=secure_monitor_server(
            password=super._getPassword(),
            hostname='127.0.0.1',
            port=MONITOR_PORT)

    # Try to set uid to server's uid. 
    # This will only work if this script is run by root.
    try:
        import pwd
        try:
            try:
                uid=string.atoi(UID)
            except:
                pass
            if type(UID) == type(""):
                uid = pwd.getpwnam(UID)[2]
            os.setuid(uid)
        except KeyError:
            zLOG.LOG("z2", zLOG.ERROR, ("can't find UID %s" % UID))

    except:
        pass


    # Start Medusa, Ye Hass!
    sys.ZServerExitCode=0
    dret = daemonize_func()
    if dret:
        sys.exit(dret)

    # if it hasn't failed at this point, create a .pid file.
    if not READ_ONLY:
        pf = open(PID_FILE, 'w')
        pid=str(os.getpid())
        pf.write(pid)
        pf.close()

    asyncore.loop()
    sys.exit(sys.ZServerExitCode)
