errors = {}
options = {}
macro_ops = {}
stages = {}
svcid = 13

SUCCESS = 0
WARNING = 1
ERROR = 2

def determine_severity(msgs):
    severity = SUCCESS
    if msgs and len(msgs) > 0:
        for msg in msgs:
            severity = max(severity, msg[0])
    return severity

def determine_action_severity(list):
    severity = SUCCESS
    if list and len(list) > 0:
        for action in list:
            severity = max(severity, determine_severity(action[2]))
    return severity

def get_option_from_code(code, options_table):
    index = (code >> 48) & 0xff
    return options_table.get(index, None)

def get_errornum_from_code(code):
    return (code >> 56) & 0xff
options[0] = "threshold"; threshold = 0L
options[1] = "rollover"; rollover = 1L
options[2] = "total_threshold"; total_threshold = 2L
options[3] = "enabled_bandwidth"; enabled_bandwidth = 3L

NEG_THRESHOLD = (13L << 56) | (threshold << 48) | 0; errors[(13L << 56) | (threshold << 48) | 0] = "Specified threshold %(threshold)s is not a non-negative number."
THRESHOLD_NAN = (13L << 56) | (threshold << 48) | 1; errors[(13L << 56) | (threshold << 48) | 1] = "Specified threshold %(threshold)s is not a number."
ROLLOVER_RANGE = (13L << 56) | (rollover << 48) | 2; errors[(13L << 56) | (rollover << 48) | 2] = "Specified cycle start %(rollover)s is out of range (must be 0 [end of month] or 1 - 27)."
ROLLOVER_NAN = (13L << 56) | (rollover << 48) | 3; errors[(13L << 56) | (rollover << 48) | 3] = "Specified cycle start %(rollover)s is not a number."
RESELLER_OVER_TOTAL_THRESHOLD = (13L << 56) | (total_threshold << 48) | 4; errors[(13L << 56) | (total_threshold << 48) | 4] = "Allocated threshold exceeds allowed limits."
RESELLER_BANDWIDTH_ENABLE_MISMATCH = (13L << 56) | (enabled_bandwidth << 48) | 5; errors[(13L << 56) | (enabled_bandwidth << 48) | 5] = "Reseller with bandwidth limiting enabled assigned site with limiting disabled."
TOTAL_THRESHOLD_NAN = (13L << 56) | (total_threshold << 48) | 6; errors[(13L << 56) | (total_threshold << 48) | 6] = "Allocated Bandwidth Threshold value %(inval)s not a number."
ENABLED_BANDWIDTH_NAN = (13L << 56) | (enabled_bandwidth << 48) | 7; errors[(13L << 56) | (enabled_bandwidth << 48) | 7] = "Enabled Bandwidth value %(inval)s not 0 or 1."

NO_PARAM = ((13L << 56) | (255L << 48)) | 0; errors[((13L << 56) | (255L << 48)) | 0] = "No parameter %(param)s available in configuration file."
DB_REMOVE_OLD_BANDWIDTH = ((13L << 56) | (255L << 48)) | 1; errors[((13L << 56) | (255L << 48)) | 1] = "Failed to remove old site bandwidth from database. DBERR: %(dberrstr)s"
DB_ADD_BANDWIDTH = ((13L << 56) | (255L << 48)) | 2; errors[((13L << 56) | (255L << 48)) | 2] = "Failed to add site bandwidth to database. DBERR: %(dberrstr)s"
DB_UPDATE_BANDWIDTH = ((13L << 56) | (255L << 48)) | 3; errors[((13L << 56) | (255L << 48)) | 3] = "Failed to update site bandwidth in database. DBERR: %(dberrstr)s"
ZERO_BANDWIDTH_WARN = ((13L << 56) | (255L << 48)) | 4; errors[((13L << 56) | (255L << 48)) | 4] = "Setting Bandwidth Threshold value to zero indicates that the threshold is unlimited"
