errors = {}
options = {}
macro_ops = {}
stages = {}
svcid = 24

SUCCESS = 0
WARNING = 1
ERROR = 2

def determine_severity(msgs):
    severity = SUCCESS
    if msgs and len(msgs) > 0:
        for msg in msgs:
            severity = max(severity, msg[0])
    return severity

def determine_action_severity(list):
    severity = SUCCESS
    if list and len(list) > 0:
        for action in list:
            severity = max(severity, determine_severity(action[2]))
    return severity

def get_option_from_code(code, options_table):
    index = (code >> 48) & 0xff
    return options_table.get(index, None)

def get_errornum_from_code(code):
    return (code >> 56) & 0xff
options[0] = "mailserver"; mailserver = 0L

MAILSERVER_NAME_LOWER = (24L << 56) | (mailserver << 48) | 0; errors[(24L << 56) | (mailserver << 48) | 0] = "Upper case letters in mail server name %(server)s were converted to lower case."
MAILSERVER_NAME_IS_HOST = (24L << 56) | (mailserver << 48) | 1; errors[(24L << 56) | (mailserver << 48) | 1] = "The mail server name is identical to the hosting computer's hostname."
MAILSERVER_NAME_INVALID = (24L << 56) | (mailserver << 48) | 2; errors[(24L << 56) | (mailserver << 48) | 2] = "The mail server name is not in valid format."
MAILSERVER_TOO_LONG = (24L << 56) | (mailserver << 48) | 3; errors[(24L << 56) | (mailserver << 48) | 3] = "The mail server name is too long."
MAILPREFIX_NAME_LOWER = (24L << 56) | (mailserver << 48) | 4; errors[(24L << 56) | (mailserver << 48) | 4] = "Upper case letters in mail server prefix %(server)s were converted to lower case."
MAILPREFIX_DOT = (24L << 56) | (mailserver << 48) | 5; errors[(24L << 56) | (mailserver << 48) | 5] = "The mail server prefix must end with a period."
MAILPREFIX_NAME_INVALID = (24L << 56) | (mailserver << 48) | 6; errors[(24L << 56) | (mailserver << 48) | 6] = "The mail server prefix is not in valid format."
MAILPREFIX_TOO_LONG = (24L << 56) | (mailserver << 48) | 7; errors[(24L << 56) | (mailserver << 48) | 7] = "The mail server prefix is too long."
MAILSERVER_EXISTS = (24L << 56) | (mailserver << 48) | 8; errors[(24L << 56) | (mailserver << 48) | 8] = "The mail server name %(server)s is already in use."
MAILSERVER_BADCHARS = (24L << 56) | (mailserver << 48) | 9; errors[(24L << 56) | (mailserver << 48) | 9] = "The mail server name %(mailserver)s contains invalid characters: %(badchars)s"
UNABLE_RESERVE_MAILSERVER = (24L << 56) | (mailserver << 48) | 10; errors[(24L << 56) | (mailserver << 48) | 10] = "Unable to reserve the mail server name '%(pattern)s', because it conflicts with '%(conflict)s', which is a %(kind)s that belongs to %(reservedby)s."

SENDMAIL_CF_CLOSE = ((24L << 56) | (255L << 48)) | 1; errors[((24L << 56) | (255L << 48)) | 1] = "Failed to close Sendmail configuration file %(file)s. Error is %(errno)d : %(errstr)s"
SENDMAIL_LOCAL_HOST_NAMES = ((24L << 56) | (255L << 48)) | 2; errors[((24L << 56) | (255L << 48)) | 2] = "Failed to set up Sendmail local host name file %(file)s. Error is %(errno)d : %(errstr)s"
SENDMAIL_LOCAL_HOST_NAMES_CLOSE = ((24L << 56) | (255L << 48)) | 3; errors[((24L << 56) | (255L << 48)) | 3] = "Failed to close Sendmail local host name file %(file)s. Error is %(errno)d : %(errstr)s"
NEWALIASES = ((24L << 56) | (255L << 48)) | 4; errors[((24L << 56) | (255L << 48)) | 4] = "Failed to run newaliases after enabling Sendmail. Error %(errno)d.\nStandard Out: %(stdout)s\nStandard Error: %(stderr)s"
USERADD = ((24L << 56) | (255L << 48)) | 5; errors[((24L << 56) | (255L << 48)) | 5] = "Failed to add mail user to domain. Error %(errno)d.\nStandard Out: %(stdout)s\nStandard Error: %(stderr)s"
GROUPADD = ((24L << 56) | (255L << 48)) | 6; errors[((24L << 56) | (255L << 48)) | 6] = "Failed to add mail group to domain. Error %(errno)d.\nStandard Out: %(stdout)s\nStandard Error: %(stderr)s"
USERDEL = ((24L << 56) | (255L << 48)) | 7; errors[((24L << 56) | (255L << 48)) | 7] = "Failed to remove mail user from domain. Error %(errno)d.\nStandard Out: %(stdout)s\nStandard Error: %(stderr)s"
RM_FILE = ((24L << 56) | (255L << 48)) | 8; errors[((24L << 56) | (255L << 48)) | 8] = "Failed to remove file %(file)s from domain. Error is %(errno)d : %(errstr)s"
MAKEMAP_MAILERTABLE = ((24L << 56) | (255L << 48)) | 11; errors[((24L << 56) | (255L << 48)) | 11] = "Failed to recreate Sendmail mailer database. Error %(errno)d.\nStandard Out: %(stdout)s\nStandard Error: %(stderr)s"
SENDMAIL_MAILERTABLE = ((24L << 56) | (255L << 48)) | 12; errors[((24L << 56) | (255L << 48)) | 12] = "Failed to create Sendmail mailer database input file %(file)s. Error is %(errno)d : %(errstr)s"
SENDMAIL_MAILERTABLE_CLOSE = ((24L << 56) | (255L << 48)) | 13; errors[((24L << 56) | (255L << 48)) | 13] = "Failed to close Sendmail mailer database input file %(file)s. Error is %(errno)d : %(errstr)s"
SENDMAIL_CREATE_SYMLINKS = ((24L << 56) | (255L << 48)) | 14; errors[((24L << 56) | (255L << 48)) | 14] = "Failed to create the symbolic link from %(from)s to %(to)s. File %(file)s. Error is %(errno)d : %(errstr)s"
SENDMAIL_DOMAIN_MAILERTABLE = ((24L << 56) | (255L << 48)) | 15; errors[((24L << 56) | (255L << 48)) | 15] = "Failed to create Sendmail mailer database input file %(file)s. Error is %(errno)d : %(errstr)s"
SENDMAIL_DOMAIN_MAILERTABLE_CLOSE = ((24L << 56) | (255L << 48)) | 16; errors[((24L << 56) | (255L << 48)) | 16] = "Failed to close Sendmail mailer database input file %(file)s. Error is %(errno)d : %(errstr)s"
MAKEMAP_DOMAIN_MAILERTABLE = ((24L << 56) | (255L << 48)) | 17; errors[((24L << 56) | (255L << 48)) | 17] = "Failed to recreate virtual domain Sendmail mailer database. Error %(errno)d.\nStandard Out: %(stdout)s\nStandard Error: %(stderr)s"
